/*
 * $Id: Display.java,v 1.2 2002/05/03 14:33:37 ymakise Exp $
 */

/*
 * ΥեΥ饤󥹤ϰʲΤ褦 BSD 饤󥹤˽򤷤ޤ
 * 㳰ȤơiɤѴġˤäѴ줿Ѵ
 *  MIDP ץꥱղä줿󥿥饤֥ΥХʥ
 * ˤĤƤϡiɤԤϤʤ븢ĥʤΤȤޤ
 *
 * Copyright (c) 2002, MAKISE Yoshitaro
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *
 * 3. Neither the name of the iModoki nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.nttdocomo.ui;

import imodoki.MainMIDlet;

public class Display {
    public static final int KEY_PRESSED_EVENT   = 0;
    public static final int KEY_RELEASED_EVENT  = 1;
    public static final int RESUME_VM_EVENT     = 4;
    public static final int RESET_VM_EVENT      = 5;
    public static final int UPDATE_VM_EVENT     = 6;
    public static final int TIMER_EXPIRED_EVENT = 7;
    public static final int MEDIA_EVENT         = 8;
    protected static final int MIN_VENDOR_EVENT = 64;
    protected static final int MAX_VENDOR_EVENT = 127;

    public static final int KEY_0        = 0x00;
    public static final int KEY_1        = 0x01;
    public static final int KEY_2        = 0x02;
    public static final int KEY_3        = 0x03;
    public static final int KEY_4        = 0x04;
    public static final int KEY_5        = 0x05;
    public static final int KEY_6        = 0x06;
    public static final int KEY_7        = 0x07;
    public static final int KEY_8        = 0x08;
    public static final int KEY_9        = 0x09;
    public static final int KEY_ASTERISK = 0x0a;
    public static final int KEY_POUND    = 0x0b;
    public static final int KEY_LEFT     = 0x10;
    public static final int KEY_UP       = 0x11;
    public static final int KEY_RIGHT    = 0x12;
    public static final int KEY_DOWN     = 0x13;
    public static final int KEY_SELECT   = 0x14;
    public static final int KEY_SOFT1    = 0x15;
    public static final int KEY_SOFT2    = 0x16;
    protected static final int MIN_VENDOR_KEY = 0x1a;
    protected static final int MAX_VENDOR_KEY = 0x1f;

    /* imodoki.MainMIDlet 黲Ȥ */
    public static javax.microedition.lcdui.Canvas s_dummyCanvas =
        new DummyCanvas();

    private static javax.microedition.lcdui.Display s_display;
    private static Frame s_currentFrame;

    public static final void setMIDPDisplay(javax.microedition.lcdui.Display display) {
        s_display = display;
    }

    static final javax.microedition.lcdui.Display getMIDPDisplay() {
        return s_display;
    }

    public static final int getWidth() {
        return s_dummyCanvas.getWidth();
    }

    public static final int getHeight() {
        return s_dummyCanvas.getHeight();
    }

    public static final boolean isColor() {
        return s_display.isColor();
    }

    public static final int numColors() {
        return s_display.numColors();
    }

    public static final void setCurrent(Frame frame) {
        s_currentFrame = frame;
        s_display.setCurrent(s_currentFrame.getMIDPDisplayable());
    }

    public static final Frame getCurrent() {
        return s_currentFrame;
    }
}
